org.bouncycastle.crypto.engines

## Class DESedeEngine

- java.lang.Object
- - org.bouncycastle.crypto.engines.DESEngine
  - - org.bouncycastle.crypto.engines.DESedeEngine

All Implemented Interfaces:
  BlockCipher

    public class DESedeEngine
    extends DESEngine

a class that provides a basic DESede (or Triple DES) engine.

### Field Summary

Fields
`protected static int` `BLOCK_SIZE`

### Constructor Summary

Constructors
Constructor and Description
`DESedeEngine()` standard constructor.

### Method Summary

Methods
`java.lang.String` `getAlgorithmName()` Return the name of the algorithm the cipher implements.
`int` `getBlockSize()` Return the block size for this cipher (in bytes).
`void` `init(boolean encrypting, CipherParameters params)` initialise a DESede cipher.
`int` `processBlock(byte[] in, int inOff, byte[] out, int outOff)` Process one block of input from the array in and write it to the out array.
`void` `reset()` Reset the cipher.

### Methods inherited from class org.bouncycastle.crypto.engines.DESEngine

`desFunc, generateWorkingKey`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### BLOCK_SIZE

    protected static final int BLOCK_SIZE

See Also:
  Constant Field Values

### Constructor Detail

#### DESedeEngine

    public DESedeEngine()

standard constructor.

### Method Detail

#### init

    public void init(boolean encrypting,
            CipherParameters params)

initialise a DESede cipher.

Specified by:
  `init` in interface `BlockCipher`
Overrides:
  `init` in class `DESEngine`
Parameters:
  `encrypting` - whether or not we are for encryption.
  `params` - the parameters required to set up the cipher.
Throws:
  `java.lang.IllegalArgumentException` - if the params argument is inappropriate.

#### getAlgorithmName

    public java.lang.String getAlgorithmName()

Description copied from interface: `BlockCipher`
Return the name of the algorithm the cipher implements.

Specified by:
  `getAlgorithmName` in interface `BlockCipher`
Overrides:
  `getAlgorithmName` in class `DESEngine`
Returns:
  the name of the algorithm the cipher implements.

#### getBlockSize

    public int getBlockSize()

Description copied from interface: `BlockCipher`
Return the block size for this cipher (in bytes).

Specified by:
  `getBlockSize` in interface `BlockCipher`
Overrides:
  `getBlockSize` in class `DESEngine`
Returns:
  the block size for this cipher in bytes.

#### processBlock

    public int processBlock(byte[] in,
                   int inOff,
                   byte[] out,
                   int outOff)

Description copied from interface: `BlockCipher`
Process one block of input from the array in and write it to the out array.

Specified by:
  `processBlock` in interface `BlockCipher`
Overrides:
  `processBlock` in class `DESEngine`
Parameters:
  `in` - the array containing the input data.
  `inOff` - offset into the in array the data starts at.
  `out` - the array the output data will be copied into.
  `outOff` - the offset into the out array the output will start at.
Returns:
  the number of bytes processed and produced.

#### reset

    public void reset()

Description copied from interface: `BlockCipher`
Reset the cipher. After resetting the cipher is in the same state as it was after the last init (if there was one).

Specified by:
  `reset` in interface `BlockCipher`
Overrides:
  `reset` in class `DESEngine`